<bugID>1358998<Summary>[meta] Stop using the :not(:target) selector in SVG for the Firefox UI</Summary><Description>I mentioned this already in bug 1337492 comment 6, but apparently I didn't file a bug.

Right now we are using :not(:target) a lot in the SVG that we use in the UI:

https://dxr.mozilla.org/mozilla-central/search?limit=10000&amp;q=not(%3Atarget

I remember suggesting a long time ago that this way of grouping icons in a single file *could* perhaps be optimized to make improve performance over having them in individual files. (The idea was that we could optimize the implementation internally so that a single SVG document would be shared between different icons.) However, this optimization does not currently exist (and would require a fair bit of work).

What currently happens when we use this mechanism is that imagelib creates a new VectorImage (and therefore SVG document instance) for each URL with a different hash (see bug 1027106). So by using the |use:not(:target)| trick we end up creating a new document instance for each icon in the file that is displayed, PLUS each document instance has to pay the parsing, DOM construction, styling, etc. overhead for all the other icons in the combined file. In other words there is only downside to this approach over having each icon in its own file.

I'd strongly suggest switching to individual files, or else using the -moz-image-rect/-moz-image-region mechanism we use elsewhere.</Description></bugID>